
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class License_productsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const license_products = await db.license_products.create(
            {
                id: data.id || undefined,
        
        product_code: data.product_code
        ||
        null
            ,
            
        product_name: data.product_name
        ||
        null
            ,
            
        version: data.version
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return license_products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const license_productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                product_code: item.product_code
            ||
            null
            ,
            
                product_name: item.product_name
            ||
            null
            ,
            
                version: item.version
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const license_products = await db.license_products.bulkCreate(license_productsData, { transaction });

        // For each item created, replace relation files
        

        return license_products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const license_products = await db.license_products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.product_code !== undefined) updatePayload.product_code = data.product_code;
        
        
        if (data.product_name !== undefined) updatePayload.product_name = data.product_name;
        
        
        if (data.version !== undefined) updatePayload.version = data.version;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await license_products.update(updatePayload, {transaction});

        
        

        
        

        

        return license_products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const license_products = await db.license_products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of license_products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of license_products) {
                await record.destroy({transaction});
            }
        });


        return license_products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const license_products = await db.license_products.findByPk(id, options);

        await license_products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await license_products.destroy({
            transaction
        });

        return license_products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const license_products = await db.license_products.findOne(
            { where },
            { transaction },
        );

        if (!license_products) {
            return license_products;
        }

        const output = license_products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.license_keys_product = await license_products.getLicense_keys_product({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.product_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'license_products',
                        'product_code',
                        filter.product_code,
                    ),
                };
            }
            
            if (filter.product_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'license_products',
                        'product_name',
                        filter.product_name,
                    ),
                };
            }
            
            if (filter.version) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'license_products',
                        'version',
                        filter.version,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'license_products',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.license_products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'license_products',
                        'product_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.license_products.findAll({
            attributes: [ 'id', 'product_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['product_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.product_name,
        }));
    }

    
};

